/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "expr.h"
#include "optabs.h"
#include "real.h"
#include "dfp.h"
#include "flags.h"
#include "output.h"
#include "insn-config.h"
#include "hard-reg-set.h"
#include "recog.h"
#include "resource.h"
#include "reload.h"
#include "toplev.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "basic-block.h"
#include "integrate.h"

#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)

/* ../../gcc/config/avr/avr.md:295 */
rtx
gen_movhi_sp_r_irq_off (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		operand1),
	3));
}

/* ../../gcc/config/avr/avr.md:305 */
rtx
gen_movhi_sp_r_irq_on (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		operand1),
	2));
}

/* ../../gcc/config/avr/avr.md:622 */
rtx
gen_addqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:826 */
rtx
gen_addsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:857 */
rtx
gen_subqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:868 */
rtx
gen_subhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:890 */
rtx
gen_subsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:958 */
rtx
gen_mulqihi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_SIGN_EXTEND (HImode,
	operand1),
	gen_rtx_SIGN_EXTEND (HImode,
	operand2)));
}

/* ../../gcc/config/avr/avr.md:969 */
rtx
gen_umulqihi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1),
	gen_rtx_ZERO_EXTEND (HImode,
	operand2)));
}

/* ../../gcc/config/avr/avr.md:1190 */
rtx
gen_andqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1201 */
rtx
gen_andhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:1232 */
rtx
gen_andsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1284 */
rtx
gen_iorqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1295 */
rtx
gen_iorhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1331 */
rtx
gen_iorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1378 */
rtx
gen_xorqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1387 */
rtx
gen_xorhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1397 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1660 */
rtx
gen_ashlhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1669 */
rtx
gen_ashlsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1758 */
rtx
gen_ashrqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1767 */
rtx
gen_ashrhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1776 */
rtx
gen_ashrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1875 */
rtx
gen_lshrhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1884 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1973 */
rtx
gen_absqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1983 */
rtx
gen_abssf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (SFmode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1996 */
rtx
gen_negqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2004 */
rtx
gen_neghi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2015 */
rtx
gen_negsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2031 */
rtx
gen_negsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SFmode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2044 */
rtx
gen_one_cmplqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2052 */
rtx
gen_one_cmplhi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2061 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2075 */
rtx
gen_extendqihi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2085 */
rtx
gen_extendqisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2095 */
rtx
gen_extendhisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2112 */
rtx
gen_zero_extendqihi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2127 */
rtx
gen_zero_extendqisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2142 */
rtx
gen_zero_extendhisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2157 */
rtx
gen_zero_extendqidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2172 */
rtx
gen_zero_extendhidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2187 */
rtx
gen_zero_extendsidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2205 */
rtx
gen_tstqi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:2222 */
rtx
gen_tsthi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:2240 */
rtx
gen_tstsi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:2261 */
rtx
gen_cmpqi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ../../gcc/config/avr/avr.md:2282 */
rtx
gen_cmphi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:2327 */
rtx
gen_cmpsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:2389 */
rtx
gen_negated_tstqi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_NEG (QImode,
	operand0));
}

/* ../../gcc/config/avr/avr.md:2389 */
rtx
gen_negated_tsthi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_NEG (HImode,
	operand0));
}

/* ../../gcc/config/avr/avr.md:2389 */
rtx
gen_negated_tstsi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_NEG (SImode,
	operand0));
}

/* ../../gcc/config/avr/avr.md:2640 */
rtx
gen_branch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2653 */
rtx
gen_difficult_branch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2668 */
rtx
gen_rvbranch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0)));
}

/* ../../gcc/config/avr/avr.md:2681 */
rtx
gen_difficult_rvbranch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0)));
}

/* ../../gcc/config/avr/avr.md:2697 */
rtx
gen_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc/config/avr/avr.md:2736 */
rtx
gen_call_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (HImode,
	operand0),
	operand1);
}

/* ../../gcc/config/avr/avr.md:2772 */
rtx
gen_call_value_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (HImode,
	operand1),
	operand2));
}

/* ../../gcc/config/avr/avr.md:2809 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc/config/avr/avr.md:2817 */
rtx
gen_indirect_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:2922 */
rtx
gen_sez (void)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	const0_rtx);
}

/* ../../gcc/config/avr/avr.md:3175 */
rtx
gen_popqi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MEM (QImode,
	gen_rtx_POST_INC (VOIDmode,
	gen_rtx_REG (HImode,
	32))));
}

/* ../../gcc/config/avr/avr.md:3183 */
rtx
gen_pophi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MEM (HImode,
	gen_rtx_POST_INC (VOIDmode,
	gen_rtx_REG (HImode,
	32))));
}

/* ../../gcc/config/avr/avr.md:3192 */
rtx
gen_enable_interrupt (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	2);
}

/* ../../gcc/config/avr/avr.md:3201 */
rtx
gen_disable_interrupt (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	3);
}

/* ../../gcc/config/avr/avr.md:3210 */
rtx
gen_call_prologue_saves (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		const0_rtx),
	0),
		operand0,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	32),
	gen_rtx_MINUS (HImode,
	gen_rtx_REG (HImode,
	32),
	operand1)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	26)),
		gen_hard_reg_clobber (HImode, 30)));
}

/* ../../gcc/config/avr/avr.md:3231 */
rtx
gen_epilogue_restores (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (4,
		gen_rtx_UNSPEC_VOLATILE (QImode,
	gen_rtvec (1,
		const0_rtx),
	1),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	28),
	gen_rtx_PLUS (HImode,
	gen_rtx_REG (HImode,
	28),
	operand0)),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	32),
	gen_rtx_REG (HImode,
	28)),
		gen_hard_reg_clobber (QImode, 30)));
}

/* ../../gcc/config/avr/avr.md:3249 */
rtx
gen_return (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:3256 */
rtx
gen_return_from_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:3266 */
rtx
gen_return_from_interrupt_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:3276 */
rtx
gen_return_from_naked_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:120 */
rtx
gen_nonlocal_goto_receiver (void)
{
  rtx _val = 0;
  start_sequence ();
  {
#line 135 "../../gcc/config/avr/avr.md"
{
    emit_move_insn (virtual_stack_vars_rtx, 
		    gen_rtx_PLUS (Pmode, hard_frame_pointer_rtx, 
				  gen_int_mode (STARTING_FRAME_OFFSET,
						Pmode)));
  /* This might change the hard frame pointer in ways that aren't
    apparent to early optimization passes, so force a clobber.  */
    emit_clobber (hard_frame_pointer_rtx);
    DONE;
  }
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	28),
	gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		const0_rtx),
	4)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:150 */
rtx
gen_nonlocal_goto (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 158 "../../gcc/config/avr/avr.md"
{
  rtx r_label = copy_to_reg (operands[1]);
  rtx r_fp = operands[3];
  rtx r_sp = operands[2];

  emit_clobber (gen_rtx_MEM (BLKmode, gen_rtx_SCRATCH (VOIDmode)));

  emit_clobber (gen_rtx_MEM (BLKmode, hard_frame_pointer_rtx));

  emit_move_insn (hard_frame_pointer_rtx, r_fp);
  emit_stack_restore (SAVE_NONLOCAL, r_sp, NULL_RTX);

  emit_use (hard_frame_pointer_rtx);
  emit_use (stack_pointer_rtx);

  emit_indirect_jump (r_label);
 
  DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
  }
  emit_insn (gen_rtx_USE (VOIDmode,
	operand0));
  emit_insn (gen_rtx_USE (VOIDmode,
	operand1));
  emit_insn (gen_rtx_USE (VOIDmode,
	operand2));
  emit_insn (gen_rtx_USE (VOIDmode,
	operand3));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:226 */
rtx
gen_movqi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 230 "../../gcc/config/avr/avr.md"
/* One of the ops has to be in a register.  */
   if (!register_operand(operand0, QImode)
       && ! (register_operand(operand1, QImode) || const0_rtx == operand1))
       operands[1] = copy_to_mode_reg(QImode, operand1);
  
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:258 */
extern rtx gen_peephole2_142 (rtx, rtx *);
rtx
gen_peephole2_142 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 267 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:272 */
rtx
gen_movhi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 276 "../../gcc/config/avr/avr.md"

{
   /* One of the ops has to be in a register.  */
  if (!register_operand(operand0, HImode)
      && !(register_operand(operand1, HImode) || const0_rtx == operands[1]))
    {
      operands[1] = copy_to_mode_reg(HImode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:317 */
extern rtx gen_peephole2_144 (rtx, rtx *);
rtx
gen_peephole2_144 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 325 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:346 */
extern rtx gen_peephole2_145 (rtx, rtx *);
rtx
gen_peephole2_145 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 355 "../../gcc/config/avr/avr.md"
{
    operands[4] = gen_rtx_REG (HImode, REGNO (operands[0]));
    operands[5] = gen_rtx_REG (HImode, REGNO (operands[1]));
  }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	operand5));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:360 */
extern rtx gen_peephole2_146 (rtx, rtx *);
rtx
gen_peephole2_146 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 369 "../../gcc/config/avr/avr.md"
{
    operands[4] = gen_rtx_REG (HImode, REGNO (operands[2]));
    operands[5] = gen_rtx_REG (HImode, REGNO (operands[3]));
  }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	operand5));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:377 */
rtx
gen_movsi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 381 "../../gcc/config/avr/avr.md"

{
  /* One of the ops has to be in a register.  */
  if (!register_operand (operand0, SImode)
      && !(register_operand (operand1, SImode) || const0_rtx == operand1))
    {
      operands[1] = copy_to_mode_reg (SImode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:393 */
extern rtx gen_peephole2_148 (rtx, rtx *);
rtx
gen_peephole2_148 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 402 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:427 */
rtx
gen_movsf (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 431 "../../gcc/config/avr/avr.md"

{
  /* One of the ops has to be in a register.  */
  if (!register_operand (operand1, SFmode)
      && !register_operand (operand0, SFmode))
    {
      operands[1] = copy_to_mode_reg (SFmode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:454 */
rtx
gen_movmemhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 460 "../../gcc/config/avr/avr.md"
{
  int prob;
  HOST_WIDE_INT count;
  enum machine_mode mode;
  rtx label = gen_label_rtx ();
  rtx loop_reg;
  rtx jump;

  /* Copy pointers into new psuedos - they will be changed.  */
  rtx addr0 = copy_to_mode_reg (Pmode, XEXP (operands[0], 0));
  rtx addr1 = copy_to_mode_reg (Pmode, XEXP (operands[1], 0));

  /* Create rtx for tmp register - we use this as scratch.  */
  rtx tmp_reg_rtx  = gen_rtx_REG (QImode, TMP_REGNO);

  if (GET_CODE (operands[2]) != CONST_INT)
    FAIL;

  count = INTVAL (operands[2]);
  if (count <= 0)
    FAIL;

  /* Work out branch probability for latter use.  */
  prob = REG_BR_PROB_BASE - REG_BR_PROB_BASE / count;

  /* See if constant fit 8 bits.  */
  mode = (count < 0x100) ? QImode : HImode;
  /* Create loop counter register.  */
  loop_reg = copy_to_mode_reg (mode, gen_int_mode (count, mode));

  /* Now create RTL code for move loop.  */
  /* Label at top of loop.  */
  emit_label (label);

  /* Move one byte into scratch and inc pointer.  */
  emit_move_insn (tmp_reg_rtx, gen_rtx_MEM (QImode, addr1));
  emit_move_insn (addr1, gen_rtx_PLUS (Pmode, addr1, const1_rtx));

  /* Move to mem and inc pointer.  */
  emit_move_insn (gen_rtx_MEM (QImode, addr0), tmp_reg_rtx);
  emit_move_insn (addr0, gen_rtx_PLUS (Pmode, addr0, const1_rtx));

  /* Decrement count.  */
  emit_move_insn (loop_reg, gen_rtx_PLUS (mode, loop_reg, constm1_rtx));

  /* Compare with zero and jump if not equal. */
  emit_cmp_and_jump_insns (loop_reg, const0_rtx, NE, NULL_RTX, mode, 1,
                           label);
  /* Set jump probability based on loop count.  */
  jump = get_last_insn ();
  REG_NOTES (jump) = gen_rtx_EXPR_LIST (REG_BR_PROB,
                    GEN_INT (prob),
                    REG_NOTES (jump));
  DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_USE (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:519 */
rtx
gen_setmemhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[6];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 527 "../../gcc/config/avr/avr.md"
{
  rtx addr0;
  int cnt8;
  enum machine_mode mode;

  /* If value to set is not zero, use the library routine.  */
  if (operands[2] != const0_rtx)
    FAIL;

  if (GET_CODE (operands[1]) != CONST_INT)
    FAIL;

  cnt8 = byte_immediate_operand (operands[1], GET_MODE (operands[1]));
  mode = cnt8 ? QImode : HImode;
  operands[5] = gen_rtx_SCRATCH (mode);
  operands[1] = copy_to_mode_reg (mode,
                                  gen_int_mode (INTVAL (operands[1]), mode));
  addr0 = copy_to_mode_reg (Pmode, XEXP (operands[0], 0));
  operands[0] = gen_rtx_MEM (BLKmode, addr0);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand2),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_rtx_CLOBBER (VOIDmode,
	operand5))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:584 */
rtx
gen_strlenhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[6];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 596 "../../gcc/config/avr/avr.md"
{
  rtx addr;
  if (! (GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) == 0))
    FAIL;
  addr = copy_to_mode_reg (Pmode, XEXP (operands[1],0));
  operands[1] = gen_rtx_MEM (BLKmode, addr); 
  operands[5] = addr;
  operands[4] = gen_reg_rtx (HImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (3,
		operand1,
		operand2,
		operand3),
	0)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand4),
	gen_rtx_PLUS (HImode,
	copy_rtx (operand4),
	constm1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	copy_rtx (operand4),
	operand5)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:636 */
rtx
gen_addhi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 641 "../../gcc/config/avr/avr.md"

{
  if (GET_CODE (operands[2]) == CONST_INT)
    {
      short tmp = INTVAL (operands[2]);
      operands[2] = GEN_INT(tmp);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:917 */
rtx
gen_mulqi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 922 "../../gcc/config/avr/avr.md"
{
  if (!AVR_HAVE_MUL)
    {
      emit_insn (gen_mulqi3_call (operands[0], operands[1], operands[2]));
      DONE;
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (QImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:941 */
rtx
gen_mulqi3_call (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_MULT (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 22))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:980 */
rtx
gen_mulhi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 985 "../../gcc/config/avr/avr.md"

{
  if (!AVR_HAVE_MUL)
    {
      emit_insn (gen_mulhi3_call (operands[0], operands[1], operands[2]));
      DONE;
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1009 */
rtx
gen_mulhi3_call (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_MULT (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 22),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1030 */
rtx
gen_mulsi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_MULT (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1057 */
rtx
gen_divmodqi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_DIV (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	25),
	gen_rtx_MOD (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 22),
		gen_hard_reg_clobber (QImode, 23))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (QImode,
	25)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1079 */
rtx
gen_udivmodqi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_UDIV (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	25),
	gen_rtx_UMOD (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 23))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (QImode,
	25)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1099 */
rtx
gen_divmodhi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	gen_rtx_DIV (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_MOD (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	22)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1121 */
rtx
gen_udivmodhi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	gen_rtx_UDIV (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_UMOD (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	22)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1143 */
rtx
gen_divmodsi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	18)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1165 */
rtx
gen_udivmodsi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	18)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1268 */
extern rtx gen_peephole2_165 (rtx, rtx *);
rtx
gen_peephole2_165 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 1277 "../../gcc/config/avr/avr.md"
{
    operands[1] = GEN_INT (INTVAL (operands[1]) & INTVAL (operands[2]));
  }
  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1412 */
rtx
gen_rotlqi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 1417 "../../gcc/config/avr/avr.md"

{
  if (INTVAL (operands[2]) != 4)
    FAIL;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1432 */
rtx
gen_rotlhi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 1437 "../../gcc/config/avr/avr.md"

{
  if (INTVAL (operands[2]) != 8)
    FAIL;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1443 */
extern rtx gen_split_168 (rtx, rtx *);
rtx
gen_split_168 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
#line 1455 "../../gcc/config/avr/avr.md"
operands[2] = gen_lowpart (QImode, operands[0]);
   operands[3] = gen_highpart (QImode, operands[0]);

   operands[4] = gen_lowpart (QImode, operands[1]);
   operands[5] = gen_highpart (QImode, operands[1]);
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand5));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand4));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1463 */
rtx
gen_rotlsi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 1468 "../../gcc/config/avr/avr.md"

{
  if (INTVAL (operands[2]) != 8
      || INTVAL (operands[2]) != 16
      || INTVAL (operands[2]) != 24)
    FAIL;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (SImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1476 */
extern rtx gen_split_170 (rtx, rtx *);
rtx
gen_split_170 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
#line 1486 "../../gcc/config/avr/avr.md"
unsigned int si_lo_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int si_hi_off = subreg_highpart_offset (HImode, SImode);

   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, si_lo_off);
   operands[3] = simplify_gen_subreg (HImode, operands[0], SImode, si_hi_off);

   operands[4] = simplify_gen_subreg (HImode, operands[1], SImode, si_lo_off);
   operands[5] = simplify_gen_subreg (HImode, operands[1], SImode, si_hi_off);

   if (REGNO (operands[0]) == REGNO(operands[1]) + 2)
     {
       emit_move_insn (operands[3], operands[4]);
       DONE;
     }
   else if (REGNO (operands[0]) == REGNO(operands[1]) - 2)
     {
       emit_move_insn (operands[2], operands[5]);
       DONE;
     }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand5));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand4));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1512 */
extern rtx gen_split_171 (rtx, rtx *);
rtx
gen_split_171 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx _val = 0;
  start_sequence ();
#line 1525 "../../gcc/config/avr/avr.md"
unsigned int si_lo_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int si_hi_off = subreg_highpart_offset (HImode, SImode);
   unsigned int hi_lo_off = subreg_lowpart_offset (QImode, HImode);
   unsigned int hi_hi_off = subreg_highpart_offset (QImode, HImode);

   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, si_lo_off);
   operands[4] = simplify_gen_subreg (HImode, operands[0], SImode, si_hi_off);
   operands[3] = simplify_gen_subreg (QImode, operands[2], HImode, hi_hi_off);
   operands[2] = simplify_gen_subreg (QImode, operands[2], HImode, hi_lo_off);
   operands[5] = simplify_gen_subreg (QImode, operands[4], HImode, hi_hi_off);
   operands[4] = simplify_gen_subreg (QImode, operands[4], HImode, hi_lo_off);

   operands[6] = simplify_gen_subreg (HImode, operands[1], SImode, si_lo_off);
   operands[8] = simplify_gen_subreg (HImode, operands[1], SImode, si_hi_off);
   operands[7] = simplify_gen_subreg (QImode, operands[6], HImode, hi_hi_off);
   operands[6] = simplify_gen_subreg (QImode, operands[6], HImode, hi_lo_off);
   operands[9] = simplify_gen_subreg (QImode, operands[8], HImode, hi_hi_off);
   operands[8] = simplify_gen_subreg (QImode, operands[8], HImode, hi_lo_off);
 
   if (REGNO (operands[0]) < REGNO(operands[1]))
     {
       emit_move_insn (operands[2], operands[9]);
       emit_move_insn (operands[3], operands[6]);
       emit_move_insn (operands[4], operands[7]);
       emit_move_insn (operands[5], operands[8]);
     }
   else
     {
       emit_move_insn (operands[5], operands[8]);
       emit_move_insn (operands[2], operands[9]);
       emit_move_insn (operands[4], operands[7]);
       emit_move_insn (operands[3], operands[6]);
     }
   DONE;
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1562 */
extern rtx gen_split_172 (rtx, rtx *);
rtx
gen_split_172 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx _val = 0;
  start_sequence ();
#line 1575 "../../gcc/config/avr/avr.md"
unsigned int si_lo_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int si_hi_off = subreg_highpart_offset (HImode, SImode);
   unsigned int hi_lo_off = subreg_lowpart_offset (QImode, HImode);
   unsigned int hi_hi_off = subreg_highpart_offset (QImode, HImode);

   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, si_lo_off);
   operands[4] = simplify_gen_subreg (HImode, operands[0], SImode, si_hi_off);
   operands[3] = simplify_gen_subreg (QImode, operands[2], HImode, hi_hi_off);
   operands[2] = simplify_gen_subreg (QImode, operands[2], HImode, hi_lo_off);
   operands[5] = simplify_gen_subreg (QImode, operands[4], HImode, hi_hi_off);
   operands[4] = simplify_gen_subreg (QImode, operands[4], HImode, hi_lo_off);

   operands[6] = simplify_gen_subreg (HImode, operands[1], SImode, si_lo_off);
   operands[8] = simplify_gen_subreg (HImode, operands[1], SImode, si_hi_off);
   operands[7] = simplify_gen_subreg (QImode, operands[6], HImode, hi_hi_off);
   operands[6] = simplify_gen_subreg (QImode, operands[6], HImode, hi_lo_off);
   operands[9] = simplify_gen_subreg (QImode, operands[8], HImode, hi_hi_off);
   operands[8] = simplify_gen_subreg (QImode, operands[8], HImode, hi_lo_off);

   if (REGNO (operands[0]) < REGNO(operands[1]))
     {
       emit_move_insn (operands[2], operands[7]);
       emit_move_insn (operands[5], operands[6]);
       emit_move_insn (operands[3], operands[8]);
       emit_move_insn (operands[4], operands[9]);
     }
   else
     {
       emit_move_insn (operands[5], operands[6]);
       emit_move_insn (operands[4], operands[9]);
       emit_move_insn (operands[3], operands[8]);
       emit_move_insn (operands[2], operands[7]);
     }
   DONE;
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1615 */
rtx
gen_ashlqi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1622 */
extern rtx gen_split_174 (rtx, rtx *);
rtx
gen_split_174 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1629 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (-16)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1631 */
extern rtx gen_split_175 (rtx, rtx *);
rtx
gen_split_175 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1639 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_ASHIFT (QImode,
	copy_rtx (operand0),
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (-32)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1641 */
extern rtx gen_split_176 (rtx, rtx *);
rtx
gen_split_176 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1649 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_ASHIFT (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (-64)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1680 */
extern rtx gen_peephole2_177 (rtx, rtx *);
rtx
gen_peephole2_177 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1689 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (-16)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1691 */
extern rtx gen_peephole2_178 (rtx, rtx *);
rtx
gen_peephole2_178 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1701 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_ASHIFT (QImode,
	copy_rtx (operand0),
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (-32)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1703 */
extern rtx gen_peephole2_179 (rtx, rtx *);
rtx
gen_peephole2_179 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1713 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_ASHIFT (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (-64)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1715 */
extern rtx gen_peephole2_180 (rtx, rtx *);
rtx
gen_peephole2_180 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1723 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1735 */
extern rtx gen_peephole2_181 (rtx, rtx *);
rtx
gen_peephole2_181 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1743 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1787 */
extern rtx gen_peephole2_182 (rtx, rtx *);
rtx
gen_peephole2_182 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1795 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1807 */
extern rtx gen_peephole2_183 (rtx, rtx *);
rtx
gen_peephole2_183 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1815 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1830 */
rtx
gen_lshrqi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1837 */
extern rtx gen_split_185 (rtx, rtx *);
rtx
gen_split_185 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1844 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (15)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1846 */
extern rtx gen_split_186 (rtx, rtx *);
rtx
gen_split_186 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1854 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_LSHIFTRT (QImode,
	copy_rtx (operand0),
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (7)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1856 */
extern rtx gen_split_187 (rtx, rtx *);
rtx
gen_split_187 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 1864 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_LSHIFTRT (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (3)])));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1895 */
extern rtx gen_peephole2_188 (rtx, rtx *);
rtx
gen_peephole2_188 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1904 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (15)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1906 */
extern rtx gen_peephole2_189 (rtx, rtx *);
rtx
gen_peephole2_189 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1916 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_LSHIFTRT (QImode,
	copy_rtx (operand0),
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (7)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1918 */
extern rtx gen_peephole2_190 (rtx, rtx *);
rtx
gen_peephole2_190 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[1] = peep2_find_free_register (1, 1, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1928 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ROTATE (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_LSHIFTRT (QImode,
	copy_rtx (operand0),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (3)]));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	copy_rtx (operand1))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1930 */
extern rtx gen_peephole2_191 (rtx, rtx *);
rtx
gen_peephole2_191 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1938 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1950 */
extern rtx gen_peephole2_192 (rtx, rtx *);
rtx
gen_peephole2_192 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1958 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2112 */
extern rtx gen_split_193 (rtx, rtx *);
rtx
gen_split_193 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2120 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (QImode, HImode);
   unsigned int high_off = subreg_highpart_offset (QImode, HImode);
   
   operands[2] = simplify_gen_subreg (QImode, operands[0], HImode, low_off);
   operands[3] = simplify_gen_subreg (QImode, operands[0], HImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2127 */
extern rtx gen_split_194 (rtx, rtx *);
rtx
gen_split_194 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2135 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int high_off = subreg_highpart_offset (HImode, SImode);
   
   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, low_off);
   operands[3] = simplify_gen_subreg (HImode, operands[0], SImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2142 */
extern rtx gen_split_195 (rtx, rtx *);
rtx
gen_split_195 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2150 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int high_off = subreg_highpart_offset (HImode, SImode);
   
   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, low_off);
   operands[3] = simplify_gen_subreg (HImode, operands[0], SImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2157 */
extern rtx gen_split_196 (rtx, rtx *);
rtx
gen_split_196 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2165 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2172 */
extern rtx gen_split_197 (rtx, rtx *);
rtx
gen_split_197 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2180 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2187 */
extern rtx gen_split_198 (rtx, rtx *);
rtx
gen_split_198 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 2195 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2389 */
extern rtx gen_split_199 (rtx, rtx *);
rtx
gen_split_199 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 2399 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	const0_rtx,
	operand0)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2389 */
extern rtx gen_split_200 (rtx, rtx *);
rtx
gen_split_200 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 2399 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	const0_rtx,
	operand0)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2389 */
extern rtx gen_split_201 (rtx, rtx *);
rtx
gen_split_201 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx _val = 0;
  start_sequence ();
#line 2399 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  emit_insn (gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	const0_rtx,
	operand0)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2406 */
rtx
gen_beq (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2414 */
rtx
gen_bne (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2422 */
rtx
gen_bge (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2430 */
rtx
gen_bgeu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2438 */
rtx
gen_blt (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2446 */
rtx
gen_bltu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2461 */
rtx
gen_ble (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2469 */
rtx
gen_bleu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2477 */
rtx
gen_bgt (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2485 */
rtx
gen_bgtu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2559 */
extern rtx gen_peephole2_212 (rtx, rtx *);
rtx
gen_peephole2_212 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2571 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_ZERO_EXTRACT (HImode,
	operand0,
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (7)]),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2573 */
extern rtx gen_peephole2_213 (rtx, rtx *);
rtx
gen_peephole2_213 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2585 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_ZERO_EXTRACT (HImode,
	operand0,
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (7)]),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2587 */
extern rtx gen_peephole2_214 (rtx, rtx *);
rtx
gen_peephole2_214 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2597 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_AND (HImode,
	operand0,
	GEN_INT (-32768L)),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2599 */
extern rtx gen_peephole2_215 (rtx, rtx *);
rtx
gen_peephole2_215 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2609 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_AND (HImode,
	operand0,
	GEN_INT (-32768L)),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2611 */
extern rtx gen_peephole2_216 (rtx, rtx *);
rtx
gen_peephole2_216 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2621 "../../gcc/config/avr/avr.md"
operands[2] = GEN_INT (-2147483647 - 1);
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_AND (SImode,
	operand0,
	operand2),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2623 */
extern rtx gen_peephole2_217 (rtx, rtx *);
rtx
gen_peephole2_217 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2633 "../../gcc/config/avr/avr.md"
operands[2] = GEN_INT (-2147483647 - 1);
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_AND (SImode,
	operand0,
	operand2),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2719 */
rtx
gen_call (rtx operand0,
	rtx operand1)
{
  return gen_rtx_CALL (VOIDmode,
	operand0,
	operand1);
}

/* ../../gcc/config/avr/avr.md:2728 */
rtx
gen_call_value (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:2891 */
rtx
gen_casesi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3,
	rtx operand4)
{
  rtx operand5;
  rtx operand6;
  rtx operand7 ATTRIBUTE_UNUSED;
  rtx operand8 ATTRIBUTE_UNUSED;
  rtx operand9 ATTRIBUTE_UNUSED;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[10];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
    operands[4] = operand4;
#line 2913 "../../gcc/config/avr/avr.md"

{
  operands[6] = gen_reg_rtx (HImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
    operand6 = operands[6];
    operand7 = operands[7];
    operand8 = operands[8];
    operand9 = operands[9];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand6,
	gen_rtx_MINUS (HImode,
	gen_rtx_SUBREG (HImode,
	operand0,
	0),
	operand1)));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	copy_rtx (operand6),
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)))));
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand4),
	pc_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand6),
	gen_rtx_PLUS (HImode,
	copy_rtx (operand6),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3))));
  emit_jump_insn (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		copy_rtx (operand6)),
	1)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	copy_rtx (operand3))),
		gen_rtx_CLOBBER (VOIDmode,
	copy_rtx (operand6)))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:3285 */
rtx
gen_prologue (void)
{
  rtx _val = 0;
  start_sequence ();
  {
#line 3288 "../../gcc/config/avr/avr.md"

  {
    expand_prologue (); 
    DONE;
  }
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:3294 */
rtx
gen_epilogue (void)
{
  rtx _val = 0;
  start_sequence ();
  {
#line 3297 "../../gcc/config/avr/avr.md"

  {
    expand_epilogue (); 
    DONE;
  }
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}



void
add_clobbers (rtx pattern ATTRIBUTE_UNUSED, int insn_code_number)
{
  switch (insn_code_number)
    {
    case 134:
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 30);
      break;

    case 133:
      XVECEXP (pattern, 0, 4) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 101:
    case 100:
    case 73:
    case 72:
    case 68:
    case 67:
    case 63:
    case 62:
    case 50:
    case 48:
    case 44:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode));
      break;

    case 42:
    case 41:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 40:
    case 39:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 21);
      break;

    case 38:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 23);
      break;

    case 37:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 22);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 23);
      break;

    case 36:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 35:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (HImode, 22);
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 21);
      break;

    case 31:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (QImode, 22);
      break;

    case 15:
      XVECEXP (pattern, 0, 3) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      break;

    case 14:
      XVECEXP (pattern, 0, 3) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode));
      break;

    default:
      gcc_unreachable ();
    }
}


int
added_clobbers_hard_reg_p (int insn_code_number)
{
  switch (insn_code_number)
    {
    case 101:
    case 100:
    case 73:
    case 72:
    case 68:
    case 67:
    case 63:
    case 62:
    case 50:
    case 48:
    case 44:
    case 15:
    case 14:
      return 0;

    case 134:
    case 133:
    case 42:
    case 41:
    case 40:
    case 39:
    case 38:
    case 37:
    case 36:
    case 35:
    case 31:
      return 1;

    default:
      gcc_unreachable ();
    }
}
