/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "flags.h"
#include "ggc.h"
#include "rtl.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "function.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"

#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "toplev.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_0[] = {
  "push %0",
  "push __zero_reg__",
};

static const char * const output_1[] = {
  "push %B0\n\tpush %A0",
  "push __zero_reg__\n\tpush __zero_reg__",
};

static const char * const output_2[] = {
  "push %D0\n\tpush %C0\n\tpush %B0\n\tpush %A0",
  "push __zero_reg__\n\tpush __zero_reg__\n\tpush __zero_reg__\n\tpush __zero_reg__",
};

static const char *
output_4 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 241 "../../gcc/config/avr/avr.md"
 return output_movqi (insn, operands, NULL);
}

static const char *
output_6 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 291 "../../gcc/config/avr/avr.md"
 return output_movhi (insn, operands, NULL);
}

static const char *
output_9 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 333 "../../gcc/config/avr/avr.md"
 return output_reload_inhi (insn, operands, NULL);
}

static const char *
output_10 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 342 "../../gcc/config/avr/avr.md"
 return output_movhi (insn, operands, NULL);
}

static const char *
output_11 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 410 "../../gcc/config/avr/avr.md"
 return output_reload_insisf (insn, operands, NULL);
}

static const char *
output_12 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 420 "../../gcc/config/avr/avr.md"
 return output_movsisf (insn, operands, NULL);
}

static const char *
output_13 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 446 "../../gcc/config/avr/avr.md"
 return output_movsisf (insn, operands, NULL);
}

static const char *
output_15 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 570 "../../gcc/config/avr/avr.md"
{
     if (which_alternative==0)
       return (AS2 (st,%a0+,__zero_reg__) CR_TAB
	       AS2 (sbiw,%A1,1) CR_TAB
	       AS1 (brne,.-6));
     else
       return (AS2 (st,%a0+,__zero_reg__) CR_TAB
	       AS2 (subi,%A1,1) CR_TAB
	       AS2 (sbci,%B1,0) CR_TAB
	       AS1 (brne,.-8));
}
}

static const char * const output_17[] = {
  "add %0,%2",
  "subi %0,lo8(-(%2))",
  "inc %0",
  "dec %0",
};

static const char *
output_20 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 678 "../../gcc/config/avr/avr.md"
{
      if (CONST_INT_P (operands[0]))
        {
	  switch(INTVAL (operands[0]))
	    {
	    case -6: 
	      return "rcall ." CR_TAB 
	             "rcall ." CR_TAB 
		     "rcall .";
	    case -5: 
	      return "rcall ." CR_TAB 
	             "rcall ." CR_TAB 
		     "push __tmp_reg__";
	    case -4: 
	      return "rcall ." CR_TAB 
	             "rcall .";
	    case -3: 
	      return "rcall ." CR_TAB 
	             "push __tmp_reg__";
	    case -2: 
	      return "rcall .";
	    case -1: 
	      return "push __tmp_reg__";
	    case 0: 
	      return "";
	    case 1: 
	      return "pop __tmp_reg__";
	    case 2: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__";
	    case 3: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 4: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 5: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    }
        }
      return "bug";
    }
}

static const char *
output_21 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 747 "../../gcc/config/avr/avr.md"
{
      if (CONST_INT_P (operands[0]))
        {
	  switch(INTVAL (operands[0]))
	    {
	    case -6: 
	      return "rcall ." CR_TAB 
		     "rcall .";
	    case -5: 
	      return "rcall ." CR_TAB 
	             "push __tmp_reg__" CR_TAB 
		     "push __tmp_reg__";
	    case -4: 
	      return "rcall ." CR_TAB 
	             "push __tmp_reg__";
	    case -3: 
	      return "rcall .";
	    case -2: 
	      return "push __tmp_reg__" CR_TAB 
		     "push __tmp_reg__";
	    case -1: 
	      return "push __tmp_reg__";
	    case 0: 
	      return "";
	    case 1: 
	      return "pop __tmp_reg__";
	    case 2: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__";
	    case 3: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 4: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 5: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    }
        }
      return "bug";
    }
}

static const char * const output_22[] = {
  "add %A0,%A2\n\tadc %B0,%B2",
  "adiw %A0,%2",
  "sbiw %A0,%n2",
  "subi %A0,lo8(-(%2))\n\tsbci %B0,hi8(-(%2))",
  "sec\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__",
  "sec\n\tsbc %A0,__zero_reg__\n\tsbc %B0,__zero_reg__",
};

static const char * const output_23[] = {
  "add %A0,%A2\n\tadc %B0,%B2\n\tadc %C0,%C2\n\tadc %D0,%D2",
  "adiw %0,%2\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "sbiw %0,%n2\n\tsbc %C0,__zero_reg__\n\tsbc %D0,__zero_reg__",
  "subi %0,lo8(-(%2))\n\tsbci %B0,hi8(-(%2))\n\tsbci %C0,hlo8(-(%2))\n\tsbci %D0,hhi8(-(%2))",
  "sec\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "sec\n\tsbc %A0,__zero_reg__\n\tsbc %B0,__zero_reg__\n\tsbc %C0,__zero_reg__\n\tsbc %D0,__zero_reg__",
};

static const char * const output_25[] = {
  "sub %0,%2",
  "subi %0,lo8(%2)",
};

static const char * const output_26[] = {
  "sub %A0,%A2\n\tsbc %B0,%B2",
  "subi %A0,lo8(%2)\n\tsbci %B0,hi8(%2)",
};

static const char * const output_28[] = {
  "sub %0,%2\n\tsbc %B0,%B2\n\tsbc %C0,%C2\n\tsbc %D0,%D2",
  "subi %A0,lo8(%2)\n\tsbci %B0,hi8(%2)\n\tsbci %C0,hlo8(%2)\n\tsbci %D0,hhi8(%2)",
};

static const char * const output_43[] = {
  "and %0,%2",
  "andi %0,lo8(%2)",
};

static const char *
output_44 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1207 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (and,%A0,%A2) CR_TAB
	    AS2 (and,%B0,%B2));
  else if (which_alternative==1)
    {
      if (GET_CODE (operands[2]) == CONST_INT)
        {
	  int mask = INTVAL (operands[2]);
	  if ((mask & 0xff) != 0xff)
	    output_asm_insn (AS2 (andi,%A0,lo8(%2)), operands);
	  if ((mask & 0xff00) != 0xff00)
	    output_asm_insn (AS2 (andi,%B0,hi8(%2)), operands);
	  return "";
        }
        return (AS2 (andi,%A0,lo8(%2)) CR_TAB
	        AS2 (andi,%B0,hi8(%2)));
     }
  return (AS2 (ldi,%3,lo8(%2)) CR_TAB
          AS2 (and,%A0,%3)     CR_TAB
          AS1 (clr,%B0));
}
}

static const char *
output_45 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1237 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (and, %0,%2)   CR_TAB
	    AS2 (and, %B0,%B2) CR_TAB
	    AS2 (and, %C0,%C2) CR_TAB
	    AS2 (and, %D0,%D2));
  else if (which_alternative==1)
    {
      if (GET_CODE (operands[2]) == CONST_INT)
        {
	  HOST_WIDE_INT mask = INTVAL (operands[2]);
	  if ((mask & 0xff) != 0xff)
	    output_asm_insn (AS2 (andi,%A0,lo8(%2)), operands);
	  if ((mask & 0xff00) != 0xff00)
	    output_asm_insn (AS2 (andi,%B0,hi8(%2)), operands);
	  if ((mask & 0xff0000L) != 0xff0000L)
	    output_asm_insn (AS2 (andi,%C0,hlo8(%2)), operands);
	  if ((mask & 0xff000000L) != 0xff000000L)
	    output_asm_insn (AS2 (andi,%D0,hhi8(%2)), operands);
	  return "";
        }
      return (AS2 (andi, %A0,lo8(%2))  CR_TAB
              AS2 (andi, %B0,hi8(%2)) CR_TAB
	      AS2 (andi, %C0,hlo8(%2)) CR_TAB
	      AS2 (andi, %D0,hhi8(%2)));
    }
  return "bug";
}
}

static const char * const output_46[] = {
  "or %0,%2",
  "ori %0,lo8(%2)",
};

static const char *
output_47 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1300 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (or,%A0,%A2) CR_TAB
	    AS2 (or,%B0,%B2));
  if (GET_CODE (operands[2]) == CONST_INT)
     {
	int mask = INTVAL (operands[2]);
	if (mask & 0xff)
	  output_asm_insn (AS2 (ori,%A0,lo8(%2)), operands);
	if (mask & 0xff00)
	  output_asm_insn (AS2 (ori,%B0,hi8(%2)), operands);
	return "";
      }
   return (AS2 (ori,%0,lo8(%2)) CR_TAB
	   AS2 (ori,%B0,hi8(%2)));
}
}

static const char * const output_48[] = {
  "ldi %3,lo8(%2)\n\tor %A0,%3",
  "ldi %3,lo8(%2)\n\tor %A0,%3\n\tldi %3,hi8(%2)\n\tor %B0,%3",
};

static const char *
output_49 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1336 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (or, %0,%2)   CR_TAB
	    AS2 (or, %B0,%B2) CR_TAB
	    AS2 (or, %C0,%C2) CR_TAB
	    AS2 (or, %D0,%D2));
  if (GET_CODE (operands[2]) == CONST_INT)
     {
	HOST_WIDE_INT mask = INTVAL (operands[2]);
	if (mask & 0xff)
	  output_asm_insn (AS2 (ori,%A0,lo8(%2)), operands);
	if (mask & 0xff00)
	  output_asm_insn (AS2 (ori,%B0,hi8(%2)), operands);
	if (mask & 0xff0000L)
	  output_asm_insn (AS2 (ori,%C0,hlo8(%2)), operands);
	if (mask & 0xff000000L)
	  output_asm_insn (AS2 (ori,%D0,hhi8(%2)), operands);
	return "";
      }
  return (AS2 (ori, %A0,lo8(%2))  CR_TAB
	  AS2 (ori, %B0,hi8(%2)) CR_TAB
	  AS2 (ori, %C0,hlo8(%2)) CR_TAB
	  AS2 (ori, %D0,hhi8(%2)));
}
}

static const char * const output_50[] = {
  "ldi %3,lo8(%2)\n\tor %A0,%3",
  "ldi %3,lo8(%2)\n\tor %A0,%3\n\tldi %3,hi8(%2)\n\tor %B0,%3\n\tldi %3,hlo8(%2)\n\tor %C0,%3\n\tldi %3,hhi8(%2)\n\tor %D0,%3",
};

static const char *
output_59 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1656 "../../gcc/config/avr/avr.md"
 return ashlqi3_out (insn, operands, NULL);
}

static const char *
output_60 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1665 "../../gcc/config/avr/avr.md"
 return ashlhi3_out (insn, operands, NULL);
}

static const char *
output_61 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1674 "../../gcc/config/avr/avr.md"
 return ashlsi3_out (insn, operands, NULL);
}

static const char *
output_62 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1731 "../../gcc/config/avr/avr.md"
 return ashlhi3_out (insn, operands, NULL);
}

static const char *
output_63 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1751 "../../gcc/config/avr/avr.md"
 return ashlsi3_out (insn, operands, NULL);
}

static const char *
output_64 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1763 "../../gcc/config/avr/avr.md"
 return ashrqi3_out (insn, operands, NULL);
}

static const char *
output_65 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1772 "../../gcc/config/avr/avr.md"
 return ashrhi3_out (insn, operands, NULL);
}

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1781 "../../gcc/config/avr/avr.md"
 return ashrsi3_out (insn, operands, NULL);
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1803 "../../gcc/config/avr/avr.md"
 return ashrhi3_out (insn, operands, NULL);
}

static const char *
output_68 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1823 "../../gcc/config/avr/avr.md"
 return ashrsi3_out (insn, operands, NULL);
}

static const char *
output_69 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1871 "../../gcc/config/avr/avr.md"
 return lshrqi3_out (insn, operands, NULL);
}

static const char *
output_70 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1880 "../../gcc/config/avr/avr.md"
 return lshrhi3_out (insn, operands, NULL);
}

static const char *
output_71 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1889 "../../gcc/config/avr/avr.md"
 return lshrsi3_out (insn, operands, NULL);
}

static const char *
output_72 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1946 "../../gcc/config/avr/avr.md"
 return lshrhi3_out (insn, operands, NULL);
}

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1966 "../../gcc/config/avr/avr.md"
 return lshrsi3_out (insn, operands, NULL);
}

static const char * const output_75[] = {
  "andi %D0,0x7f",
  "clt\n\tbld %D0,7",
};

static const char * const output_77[] = {
  "com %B0\n\tneg %A0\n\tsbci %B0,lo8(-1)",
  "com %B0\n\tneg %A0\n\tsbc %B0,__zero_reg__\n\tinc %B0",
  "clr %A0\n\tclr %B0\n\tsub %A0,%A1\n\tsbc %B0,%B1",
};

static const char * const output_78[] = {
  "com %D0\n\tcom %C0\n\tcom %B0\n\tneg %A0\n\tsbci %B0,lo8(-1)\n\tsbci %C0,lo8(-1)\n\tsbci %D0,lo8(-1)",
  "com %D0\n\tcom %C0\n\tcom %B0\n\tcom %A0\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "clr %A0\n\tclr %B0\n\t{clr %C0\n\tclr %D0|movw %C0,%A0}\n\tsub %A0,%A1\n\tsbc %B0,%B1\n\tsbc %C0,%C1\n\tsbc %D0,%D1",
};

static const char * const output_79[] = {
  "subi %D0,0x80",
  "bst %D0,7\n\tcom %D0\n\tbld %D0,7\n\tcom %D0",
};

static const char * const output_83[] = {
  "clr %B0\n\tsbrc %0,7\n\tcom %B0",
  "mov %A0,%A1\n\tclr %B0\n\tsbrc %A0,7\n\tcom %B0",
};

static const char * const output_84[] = {
  "clr %B0\n\tsbrc %A0,7\n\tcom %B0\n\tmov %C0,%B0\n\tmov %D0,%B0",
  "mov %A0,%A1\n\tclr %B0\n\tsbrc %A0,7\n\tcom %B0\n\tmov %C0,%B0\n\tmov %D0,%B0",
};

static const char * const output_85[] = {
  "clr %C0\n\tsbrc %B0,7\n\tcom %C0\n\tmov %D0,%C0",
  "{mov %A0,%A1\n\tmov %B0,%B1|movw %A0,%A1}\n\tclr %C0\n\tsbrc %B0,7\n\tcom %C0\n\tmov %D0,%C0",
};

static const char *
output_94 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2226 "../../gcc/config/avr/avr.md"
 return out_tsthi (insn,NULL);
}

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2244 "../../gcc/config/avr/avr.md"
 return out_tstsi (insn,NULL);
}

static const char * const output_98[] = {
  "cp %0,%1",
  "cpi %0,lo8(%1)",
};

static const char *
output_100 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2288 "../../gcc/config/avr/avr.md"
{
  switch (which_alternative)
    {
    case 0:
      return (AS2 (cp,%A0,%A1) CR_TAB
              AS2 (cpc,%B0,%B1));
    case 1:
      if (reg_unused_after (insn, operands[0])
          && INTVAL (operands[1]) >= 0 && INTVAL (operands[1]) <= 63
          && test_hard_reg_class (ADDW_REGS, operands[0]))
        return AS2 (sbiw,%0,%1);
       else
        return (AS2 (cpi,%0,%1) CR_TAB
                AS2 (cpc,%B0,__zero_reg__));
    case 2:
      if (reg_unused_after (insn, operands[0]))
        return (AS2 (subi,%0,lo8(%1))  CR_TAB
                AS2 (sbci,%B0,hi8(%1)));
      else
        return (AS2 (ldi, %2,hi8(%1))  CR_TAB
	        AS2 (cpi, %A0,lo8(%1)) CR_TAB
	        AS2 (cpc, %B0,%2));
   case 3:
      return (AS2 (ldi, %2,lo8(%1))  CR_TAB
	      AS2 (cp, %A0,%2) CR_TAB
	      AS2 (cpc, %B0,__zero_reg__));

   case 4:
      return (AS2 (ldi, %2,lo8(%1))  CR_TAB
              AS2 (cp, %A0,%2)       CR_TAB
              AS2 (ldi, %2,hi8(%1)) CR_TAB
	      AS2 (cpc, %B0,%2));
    }
  return "bug";
}
}

static const char *
output_101 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2333 "../../gcc/config/avr/avr.md"
{
  switch (which_alternative)
    {
    case 0:
      return (AS2 (cp,%A0,%A1) CR_TAB
              AS2 (cpc,%B0,%B1) CR_TAB
	      AS2 (cpc,%C0,%C1) CR_TAB
	      AS2 (cpc,%D0,%D1));
    case 1:
      if (reg_unused_after (insn, operands[0])
          && INTVAL (operands[1]) >= 0 && INTVAL (operands[1]) <= 63
          && test_hard_reg_class (ADDW_REGS, operands[0]))
        return (AS2 (sbiw,%0,%1) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
      else
        return (AS2 (cpi,%A0,lo8(%1))  CR_TAB
                AS2 (cpc,%B0,__zero_reg__) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
    case 2:
      if (reg_unused_after (insn, operands[0]))
        return (AS2 (subi,%A0,lo8(%1))  CR_TAB
                AS2 (sbci,%B0,hi8(%1))  CR_TAB
                AS2 (sbci,%C0,hlo8(%1))  CR_TAB
                AS2 (sbci,%D0,hhi8(%1)));
      else
       return (AS2 (cpi, %A0,lo8(%1))   CR_TAB
	       AS2 (ldi, %2,hi8(%1))  CR_TAB
	       AS2 (cpc, %B0,%2)       CR_TAB
	       AS2 (ldi, %2,hlo8(%1))  CR_TAB
	       AS2 (cpc, %C0,%2)       CR_TAB
	       AS2 (ldi, %2,hhi8(%1)) CR_TAB
	       AS2 (cpc, %D0,%2));
    case 3:
        return (AS2 (ldi,%2,lo8(%1))        CR_TAB
                AS2 (cp,%A0,%2)            CR_TAB
                AS2 (cpc,%B0,__zero_reg__) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
    case 4:
       return (AS2 (ldi, %2,lo8(%1))   CR_TAB
               AS2 (cp, %A0,%2)        CR_TAB
	       AS2 (ldi, %2,hi8(%1))  CR_TAB
	       AS2 (cpc, %B0,%2)       CR_TAB
	       AS2 (ldi, %2,hlo8(%1))  CR_TAB
	       AS2 (cpc, %C0,%2)       CR_TAB
	       AS2 (ldi, %2,hhi8(%1)) CR_TAB
	       AS2 (cpc, %D0,%2));
    }
  return "bug";
}
}

static const char *
output_105 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2506 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_106 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2527 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_107 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2548 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_108 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2648 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0],insn), 0);
}

static const char *
output_109 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2661 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0],insn), 0);
}

static const char *
output_110 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2676 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0], insn), 1);
}

static const char *
output_111 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2689 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0], insn), 1);
}

static const char *
output_112 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2701 "../../gcc/config/avr/avr.md"
{
  if (AVR_HAVE_JMP_CALL && get_attr_length (insn) != 1)
    return AS1 (jmp,%0);
  return AS1 (rjmp,%0);
}
}

static const char *
output_113 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2742 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
     return "%!icall";
  else if (which_alternative==1)
    {
      if (AVR_HAVE_MOVW)
	return (AS2 (movw, r30, %0) CR_TAB
               "%!icall");
      else
	return (AS2 (mov, r30, %A0) CR_TAB
		AS2 (mov, r31, %B0) CR_TAB
		"%!icall");
    }
  else if (which_alternative==2)
    return AS1(%~call,%c0);
  return (AS2 (ldi,r30,lo8(%0)) CR_TAB
          AS2 (ldi,r31,hi8(%0)) CR_TAB
          "%!icall");
}
}

static const char *
output_114 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2779 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
     return "%!icall";
  else if (which_alternative==1)
    {
      if (AVR_HAVE_MOVW)
	return (AS2 (movw, r30, %1) CR_TAB
		"%!icall");
      else
	return (AS2 (mov, r30, %A1) CR_TAB
		AS2 (mov, r31, %B1) CR_TAB
		"%!icall");
    }
  else if (which_alternative==2)
    return AS1(%~call,%c1);
  return (AS2 (ldi, r30, lo8(%1)) CR_TAB
          AS2 (ldi, r31, hi8(%1)) CR_TAB
          "%!icall");
}
}

static const char * const output_116[] = {
  "ijmp",
  "push %A0\n\tpush %B0\n\tret",
};

static const char * const output_118[] = {
  "ijmp",
  "push %A0\n\tpush %B0\n\tret",
};

static const char *
output_123 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2936 "../../gcc/config/avr/avr.md"
{
  operands[2] = GEN_INT (exact_log2 (~INTVAL (operands[1]) & 0xff));
  return AS2 (cbi,%0-0x20,%2);
}
}

static const char *
output_124 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2948 "../../gcc/config/avr/avr.md"
{
  operands[2] = GEN_INT (exact_log2 (INTVAL (operands[1]) & 0xff));
  return AS2 (sbi,%0-0x20,%2);
}
}

static const char *
output_125 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2968 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_126 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2988 "../../gcc/config/avr/avr.md"
{
  operands[3] = operands[2];
  operands[2] = GEN_INT (7);
  return avr_out_sbxx_branch (insn, operands);
}
}

static const char *
output_127 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 3015 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_128 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 3034 "../../gcc/config/avr/avr.md"
{
  operands[3] = operands[2];
  operands[2] = GEN_INT (7);
  return avr_out_sbxx_branch (insn, operands);
}
}

static const char *
output_221 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 3064 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  if (test_hard_reg_class (ADDW_REGS, operands[0]))
    output_asm_insn (AS2 (sbiw,%0,1) CR_TAB
		     AS2 (sbc,%C0,__zero_reg__) CR_TAB
		     AS2 (sbc,%D0,__zero_reg__) "\n", operands);
  else
    output_asm_insn (AS2 (subi,%A0,1) CR_TAB
		     AS2 (sbc,%B0,__zero_reg__) CR_TAB
		     AS2 (sbc,%C0,__zero_reg__) CR_TAB
		     AS2 (sbc,%D0,__zero_reg__) "\n", operands);
  switch (avr_jump_mode (operands[2],insn))
  {
    case 1:
      return AS1 (brcc,%2);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%2));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%2));
}
}

static const char *
output_222 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 3102 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  if (test_hard_reg_class (ADDW_REGS, operands[0]))
    output_asm_insn (AS2 (sbiw,%0,1), operands);
  else
    output_asm_insn (AS2 (subi,%A0,1) CR_TAB
		     AS2 (sbc,%B0,__zero_reg__) "\n", operands);
  switch (avr_jump_mode (operands[2],insn))
  {
    case 1:
      return AS1 (brcc,%2);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%2));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%2));
}
}

static const char *
output_223 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 3134 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  cc_status.value1 = operands[0];
  cc_status.flags |= CC_OVERFLOW_UNUSABLE;
  output_asm_insn (AS2 (subi,%A0,1), operands);
  switch (avr_jump_mode (operands[1],insn))
  {
    case 1:
      return AS1 (brcc,%1);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%1));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%1));
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    reg_or_0_operand,
    "r,L",
    QImode,
    0,
    1
  },
  {
    reg_or_0_operand,
    "r,L",
    HImode,
    0,
    1
  },
  {
    reg_or_0_operand,
    "r,L",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SFmode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,d,Qm,r,q,r,*r",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,i,rL,Qm,r,q,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=l",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=q,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,q",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "=q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,m,d,*r,q,r",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "r,m,rL,i,i,r,q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,Qm,!d,r",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,Qm,rL,i,i",
    SImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,Qm,!d,r",
    SFmode,
    0,
    1
  },
  {
    general_operand,
    "r,G,Qm,r,F,F",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=0",
    HImode,
    0,
    0
  },
  {
    scratch_operand,
    "=&1",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "e,e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "!w,d",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "n,n",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=0,0",
    HImode,
    0,
    0
  },
  {
    scratch_operand,
    "=&1,&1",
    HImode,
    0,
    0
  },
  {
    register_operand,
    "=e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i,P,N",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    avr_sp_immediate_operand,
    "R",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "=q",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "q",
    HImode,
    0,
    1
  },
  {
    avr_sp_immediate_operand,
    "R",
    QImode,
    0,
    1
  },
  {
    stack_register_operand,
    "=q",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,!w,!w,d,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0,0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,I,J,i,P,N",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,!w,!w,d,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0,0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,I,J,i,P,N",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=&r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i,M",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,d",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "M,i",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "M,i",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "=&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,!d,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,0,0,0,0",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,K,n,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,r,0,0,0",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,O,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,r,0,0,0",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,O,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r,0,0",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "L,P,O,K,n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r,0",
    SImode,
    0,
    1
  },
  {
    const_int_operand,
    "L,P,O,n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r,r,r,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,0,0,0",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=d,r",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "=!d,r,&r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=!d,r,&r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,&r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "!w,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,d",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,d,d,r,r",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,M,i,M,i",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d,&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "r,d,d,r,r",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,M,i,M,i",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d,&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    SImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    simple_comparison_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    difficult_comparison_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    nonmemory_operand,
    "!z,*r,s,n",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "X,X,X,X",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r",
    VOIDmode,
    0,
    1
  },
  {
    nonmemory_operand,
    "!z,*r,s,n",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "X,X,X,X",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "!z,*r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "z",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "!z,*r",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "z",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    single_zero_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    gelt_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    high_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    gelt_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    high_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    general_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    general_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    general_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "",
    QImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    odd_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    odd_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "",
    SImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    SFmode,
    0,
    1
  },
  {
    general_operand,
    "",
    SFmode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "",
    HImode,
    0,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "",
    QImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    call_insn_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    call_insn_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    scratch_operand,
    "",
    QImode,
    0,
    0
  },
  {
    d_register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data insn_data[] = 
{
  /* ../../gcc/config/avr/avr.md:179 */
  {
    "*pushqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_0 },
#else
    { 0, output_0, 0 },
#endif
    0,
    &operand_data[1],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:189 */
  {
    "*pushhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    0,
    &operand_data[2],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:198 */
  {
    "*pushsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_2 },
#else
    { 0, output_2, 0 },
#endif
    0,
    &operand_data[3],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:207 */
  {
    "*pushsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "push %D0\n\
	push %C0\n\
	push %B0\n\
	push %A0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[4],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:236 */
  {
    "*movqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_4 },
#else
    { 0, 0, output_4 },
#endif
    0,
    &operand_data[5],
    2,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:248 */
  {
    "*reload_inqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi %2,lo8(%1)\n\
	mov %0,%2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[7],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:286 */
  {
    "*movhi_sp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_6 },
#else
    { 0, 0, output_6 },
#endif
    0,
    &operand_data[10],
    2,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:295 */
  {
    "movhi_sp_r_irq_off",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "out __SP_H__, %B1\n\
	out __SP_L__, %A1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_movhi_sp_r_irq_off,
    &operand_data[12],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:305 */
  {
    "movhi_sp_r_irq_on",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cli\n\
        out __SP_H__, %B1\n\
	sei\n\
	out __SP_L__, %A1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_movhi_sp_r_irq_on,
    &operand_data[12],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:328 */
  {
    "*reload_inhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_9 },
#else
    { 0, 0, output_9 },
#endif
    0,
    &operand_data[14],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:337 */
  {
    "*movhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_10 },
#else
    { 0, 0, output_10 },
#endif
    0,
    &operand_data[17],
    2,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:405 */
  {
    "*reload_insi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_11 },
#else
    { 0, 0, output_11 },
#endif
    0,
    &operand_data[19],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:415 */
  {
    "*movsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_12 },
#else
    { 0, 0, output_12 },
#endif
    0,
    &operand_data[22],
    2,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:441 */
  {
    "*movsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_13 },
#else
    { 0, 0, output_13 },
#endif
    0,
    &operand_data[24],
    2,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:548 */
  {
    "*clrmemqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "st %a0+,__zero_reg__\n\
        dec %1\n\
	brne .-6",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[26],
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:562 */
  {
    "*clrmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_15 },
#else
    { 0, 0, output_15 },
#endif
    0,
    &operand_data[31],
    5,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:606 */
  {
    "*strlenhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ld __tmp_reg__,%a0+\n\
	tst __tmp_reg__\n\
	brne .-6",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[36],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:622 */
  {
    "addqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_17 },
#else
    { 0, output_17, 0 },
#endif
    (insn_gen_fn) gen_addqi3,
    &operand_data[39],
    3,
    0,
    4,
    2
  },
  /* ../../gcc/config/avr/avr.md:651 */
  {
    "*addhi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%1\n\
	adc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[42],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:662 */
  {
    "*addhi3_zero_extend1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%2\n\
	adc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[45],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:673 */
  {
    "*addhi3_sp_R_pc2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_20 },
#else
    { 0, 0, output_20 },
#endif
    0,
    &operand_data[48],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:742 */
  {
    "*addhi3_sp_R_pc3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_21 },
#else
    { 0, 0, output_21 },
#endif
    0,
    &operand_data[51],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:810 */
  {
    "*addhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_22 },
#else
    { 0, output_22, 0 },
#endif
    0,
    &operand_data[54],
    3,
    0,
    6,
    2
  },
  /* ../../gcc/config/avr/avr.md:826 */
  {
    "addsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_23 },
#else
    { 0, output_23, 0 },
#endif
    (insn_gen_fn) gen_addsi3,
    &operand_data[57],
    3,
    0,
    6,
    2
  },
  /* ../../gcc/config/avr/avr.md:842 */
  {
    "*addsi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%1\n\
	adc %B0,__zero_reg__\n\
	adc %C0,__zero_reg__\n\
	adc %D0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[60],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:857 */
  {
    "subqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_25 },
#else
    { 0, output_25, 0 },
#endif
    (insn_gen_fn) gen_subqi3,
    &operand_data[63],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:868 */
  {
    "subhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    (insn_gen_fn) gen_subhi3,
    &operand_data[66],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:879 */
  {
    "*subhi3_zero_extend1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %A0,%2\n\
	sbc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[69],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:890 */
  {
    "subsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    (insn_gen_fn) gen_subsi3,
    &operand_data[72],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:901 */
  {
    "*subsi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %A0,%2\n\
	sbc %B0,__zero_reg__\n\
	sbc %C0,__zero_reg__\n\
	sbc %D0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[75],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:930 */
  {
    "*mulqi3_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %1,%2\n\
	mov %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[78],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:950 */
  {
    "*mulqi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:958 */
  {
    "mulqihi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "muls %1,%2\n\
	movw %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_mulqihi3,
    &operand_data[81],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:969 */
  {
    "umulqihi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %1,%2\n\
	movw %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_umulqihi3,
    &operand_data[84],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:994 */
  {
    "*mulhi3_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %A1,%A2\n\
	movw %0,r0\n\
	mul %A1,%B2\n\
	add %B0,r0\n\
	mul %B1,%A2\n\
	add %B0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[87],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1019 */
  {
    "*mulhi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1040 */
  {
    "*mulsi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1069 */
  {
    "*divmodqi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1090 */
  {
    "*udivmodqi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1111 */
  {
    "*divmodhi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1133 */
  {
    "*udivmodhi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1155 */
  {
    "*divmodsi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1177 */
  {
    "*udivmodsi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1190 */
  {
    "andqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_43 },
#else
    { 0, output_43, 0 },
#endif
    (insn_gen_fn) gen_andqi3,
    &operand_data[90],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1201 */
  {
    "andhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_44 },
#else
    { 0, 0, output_44 },
#endif
    (insn_gen_fn) gen_andhi3,
    &operand_data[93],
    4,
    0,
    3,
    3
  },
  /* ../../gcc/config/avr/avr.md:1232 */
  {
    "andsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_45 },
#else
    { 0, 0, output_45 },
#endif
    (insn_gen_fn) gen_andsi3,
    &operand_data[97],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1284 */
  {
    "iorqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    (insn_gen_fn) gen_iorqi3,
    &operand_data[90],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1295 */
  {
    "iorhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_47 },
#else
    { 0, 0, output_47 },
#endif
    (insn_gen_fn) gen_iorhi3,
    &operand_data[100],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1319 */
  {
    "*iorhi3_clobber",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    0,
    &operand_data[103],
    4,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1331 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_49 },
#else
    { 0, 0, output_49 },
#endif
    (insn_gen_fn) gen_iorsi3,
    &operand_data[97],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1363 */
  {
    "*iorsi3_clobber",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_50 },
#else
    { 0, output_50, 0 },
#endif
    0,
    &operand_data[107],
    4,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1378 */
  {
    "xorqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorqi3,
    &operand_data[111],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1387 */
  {
    "xorhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2\n\
	eor %B0,%B2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorhi3,
    &operand_data[114],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1397 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2\n\
	eor %B0,%B2\n\
	eor %C0,%C2\n\
	eor %D0,%D2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorsi3,
    &operand_data[117],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1423 */
  {
    "*rotlqi3_4",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "swap %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[120],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1443 */
  {
    "*rotlhi3_8",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov __tmp_reg__,%A0\n\
	mov %A0,%B0\n\
	mov %B0, __tmp_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[122],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1476 */
  {
    "*rotlsi3_16",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "{mov __tmp_reg__,%A1\n\tmov %A0,%C1\n\tmov %C0, __tmp_reg__\n\tmov __tmp_reg__,%B1\n\tmov %B0,%D1\n\tmov %D0, __tmp_reg__|movw __tmp_reg__,%A1\n\tmovw %A0,%C1\n\tmovw %C0, __tmp_reg__\n\tclr __zero_reg__}",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[124],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1512 */
  {
    "*rotlsi3_8",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov __tmp_reg__,%D1\n\
	mov %D0,%C1\n\
	mov %C0,%B1\n\
	mov %B0,%A1\n\
	mov %A0, __tmp_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[124],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1562 */
  {
    "*rotlsi3_24",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov __tmp_reg__,%A1\n\
	mov %A0,%B1\n\
	mov %B0,%C1\n\
	mov %C0,%D1\n\
	mov %D0, __tmp_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[124],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1651 */
  {
    "*ashlqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_59 },
#else
    { 0, 0, output_59 },
#endif
    0,
    &operand_data[126],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1660 */
  {
    "ashlhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_60 },
#else
    { 0, 0, output_60 },
#endif
    (insn_gen_fn) gen_ashlhi3,
    &operand_data[129],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1669 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_61 },
#else
    { 0, 0, output_61 },
#endif
    (insn_gen_fn) gen_ashlsi3,
    &operand_data[132],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1725 */
  {
    "*ashlhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_62 },
#else
    { 0, 0, output_62 },
#endif
    0,
    &operand_data[135],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1745 */
  {
    "*ashlsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_63 },
#else
    { 0, 0, output_63 },
#endif
    0,
    &operand_data[139],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1758 */
  {
    "ashrqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_64 },
#else
    { 0, 0, output_64 },
#endif
    (insn_gen_fn) gen_ashrqi3,
    &operand_data[143],
    3,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:1767 */
  {
    "ashrhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_65 },
#else
    { 0, 0, output_65 },
#endif
    (insn_gen_fn) gen_ashrhi3,
    &operand_data[129],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1776 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    (insn_gen_fn) gen_ashrsi3,
    &operand_data[132],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1797 */
  {
    "*ashrhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    0,
    &operand_data[135],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1817 */
  {
    "*ashrsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_68 },
#else
    { 0, 0, output_68 },
#endif
    0,
    &operand_data[139],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1866 */
  {
    "*lshrqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_69 },
#else
    { 0, 0, output_69 },
#endif
    0,
    &operand_data[126],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1875 */
  {
    "lshrhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_70 },
#else
    { 0, 0, output_70 },
#endif
    (insn_gen_fn) gen_lshrhi3,
    &operand_data[129],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1884 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_71 },
#else
    { 0, 0, output_71 },
#endif
    (insn_gen_fn) gen_lshrsi3,
    &operand_data[132],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1940 */
  {
    "*lshrhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_72 },
#else
    { 0, 0, output_72 },
#endif
    0,
    &operand_data[135],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1960 */
  {
    "*lshrsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    0,
    &operand_data[139],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1973 */
  {
    "absqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sbrc %0,7\n\
	neg %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_absqi2,
    &operand_data[120],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1983 */
  {
    "abssf2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_75 },
#else
    { 0, output_75, 0 },
#endif
    (insn_gen_fn) gen_abssf2,
    &operand_data[146],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1996 */
  {
    "negqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_negqi2,
    &operand_data[120],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2004 */
  {
    "neghi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_77 },
#else
    { 0, output_77, 0 },
#endif
    (insn_gen_fn) gen_neghi2,
    &operand_data[148],
    2,
    0,
    3,
    2
  },
  /* ../../gcc/config/avr/avr.md:2015 */
  {
    "negsi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_78 },
#else
    { 0, output_78, 0 },
#endif
    (insn_gen_fn) gen_negsi2,
    &operand_data[150],
    2,
    0,
    3,
    2
  },
  /* ../../gcc/config/avr/avr.md:2031 */
  {
    "negsf2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_79 },
#else
    { 0, output_79, 0 },
#endif
    (insn_gen_fn) gen_negsf2,
    &operand_data[146],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2044 */
  {
    "one_cmplqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplqi2,
    &operand_data[120],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2052 */
  {
    "one_cmplhi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0\n\
	com %B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplhi2,
    &operand_data[69],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2061 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0\n\
	com %B0\n\
	com %C0\n\
	com %D0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplsi2,
    &operand_data[75],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2075 */
  {
    "extendqihi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_83 },
#else
    { 0, output_83, 0 },
#endif
    (insn_gen_fn) gen_extendqihi2,
    &operand_data[152],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2085 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_84 },
#else
    { 0, output_84, 0 },
#endif
    (insn_gen_fn) gen_extendqisi2,
    &operand_data[154],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2095 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_85 },
#else
    { 0, output_85, 0 },
#endif
    (insn_gen_fn) gen_extendhisi2,
    &operand_data[156],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2112 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqihi2,
    &operand_data[42],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2127 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqisi2,
    &operand_data[60],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2142 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendhisi2,
    &operand_data[158],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2157 */
  {
    "zero_extendqidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqidi2,
    &operand_data[160],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2172 */
  {
    "zero_extendhidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendhidi2,
    &operand_data[162],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2187 */
  {
    "zero_extendsidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendsidi2,
    &operand_data[164],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2205 */
  {
    "tstqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "tst %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_tstqi,
    &operand_data[27],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2213 */
  {
    "*reversed_tstqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[27],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2222 */
  {
    "tsthi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_94 },
#else
    { 0, 0, output_94 },
#endif
    (insn_gen_fn) gen_tsthi,
    &operand_data[166],
    1,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:2230 */
  {
    "*reversed_tsthi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%A0\n\
	cpc __zero_reg__,%B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[13],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2240 */
  {
    "tstsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    (insn_gen_fn) gen_tstsi,
    &operand_data[119],
    1,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2248 */
  {
    "*reversed_tstsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%A0\n\
	cpc __zero_reg__,%B0\n\
	cpc __zero_reg__,%C0\n\
	cpc __zero_reg__,%D0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[119],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2261 */
  {
    "cmpqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_98 },
#else
    { 0, output_98, 0 },
#endif
    (insn_gen_fn) gen_cmpqi,
    &operand_data[167],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2272 */
  {
    "*cmpqi_sign_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpi %0,lo8(%1)",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[169],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2282 */
  {
    "cmphi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_100 },
#else
    { 0, 0, output_100 },
#endif
    (insn_gen_fn) gen_cmphi,
    &operand_data[171],
    3,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:2327 */
  {
    "cmpsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_101 },
#else
    { 0, 0, output_101 },
#endif
    (insn_gen_fn) gen_cmpsi,
    &operand_data[174],
    3,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "negated_tstqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_negated_tstqi,
    &operand_data[177],
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "negated_tsthi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_negated_tsthi,
    &operand_data[178],
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "negated_tstsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_negated_tstsi,
    &operand_data[179],
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2494 */
  {
    "*sbrx_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_105 },
#else
    { 0, 0, output_105 },
#endif
    0,
    &operand_data[180],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2516 */
  {
    "*sbrx_and_branchhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_106 },
#else
    { 0, 0, output_106 },
#endif
    0,
    &operand_data[184],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2537 */
  {
    "*sbrx_and_branchsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_107 },
#else
    { 0, 0, output_107 },
#endif
    0,
    &operand_data[188],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2640 */
  {
    "branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_108 },
#else
    { 0, 0, output_108 },
#endif
    (insn_gen_fn) gen_branch,
    &operand_data[191],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2653 */
  {
    "difficult_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_109 },
#else
    { 0, 0, output_109 },
#endif
    (insn_gen_fn) gen_difficult_branch,
    &operand_data[193],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2668 */
  {
    "rvbranch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_110 },
#else
    { 0, 0, output_110 },
#endif
    (insn_gen_fn) gen_rvbranch,
    &operand_data[191],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2681 */
  {
    "difficult_rvbranch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_111 },
#else
    { 0, 0, output_111 },
#endif
    (insn_gen_fn) gen_difficult_rvbranch,
    &operand_data[193],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2697 */
  {
    "jump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_112 },
#else
    { 0, 0, output_112 },
#endif
    (insn_gen_fn) gen_jump,
    &operand_data[183],
    1,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2736 */
  {
    "call_insn",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_113 },
#else
    { 0, 0, output_113 },
#endif
    (insn_gen_fn) gen_call_insn,
    &operand_data[195],
    2,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:2772 */
  {
    "call_value_insn",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_114 },
#else
    { 0, 0, output_114 },
#endif
    (insn_gen_fn) gen_call_value_insn,
    &operand_data[197],
    3,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:2809 */
  {
    "nop",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_nop,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2817 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_116 },
#else
    { 0, output_116, 0 },
#endif
    (insn_gen_fn) gen_indirect_jump,
    &operand_data[200],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2826 */
  {
    "*indirect_jump_avr6",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eijmp",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[201],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2836 */
  {
    "*tablejump_rjmp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_118 },
#else
    { 0, output_118, 0 },
#endif
    0,
    &operand_data[202],
    2,
    1,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2849 */
  {
    "*tablejump_lib",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "jmp __tablejump2__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[204],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2859 */
  {
    "*tablejump_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsl r30\n\
	rol r31\n\
	lpm __tmp_reg__,Z+\n\
	lpm r31,Z\n\
	mov r30,__tmp_reg__\n\
	%!ijmp",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[204],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2874 */
  {
    "*tablejump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsl r30\n\
	rol r31\n\
	lpm\n\
	inc r30\n\
	push r0\n\
	lpm\n\
	push r0\n\
	ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[204],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2922 */
  {
    "sez",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sez",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_sez,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2931 */
  {
    "*cbi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_123 },
#else
    { 0, 0, output_123 },
#endif
    0,
    &operand_data[206],
    2,
    1,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2943 */
  {
    "*sbi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_124 },
#else
    { 0, 0, output_124 },
#endif
    0,
    &operand_data[208],
    2,
    1,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2956 */
  {
    "*sbix_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_125 },
#else
    { 0, 0, output_125 },
#endif
    0,
    &operand_data[210],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2979 */
  {
    "*sbix_branch_bit7",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_126 },
#else
    { 0, 0, output_126 },
#endif
    0,
    &operand_data[214],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:3003 */
  {
    "*sbix_branch_tmp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_127 },
#else
    { 0, 0, output_127 },
#endif
    0,
    &operand_data[217],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:3025 */
  {
    "*sbix_branch_tmp_bit7",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_128 },
#else
    { 0, 0, output_128 },
#endif
    0,
    &operand_data[221],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:3175 */
  {
    "popqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "pop %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_popqi,
    &operand_data[78],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:3183 */
  {
    "pophi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "pop %A0\n\tpop %B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_pophi,
    &operand_data[14],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:3192 */
  {
    "enable_interrupt",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sei",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_enable_interrupt,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3201 */
  {
    "disable_interrupt",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cli",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_disable_interrupt,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3210 */
  {
    "call_prologue_saves",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi r30,lo8(gs(1f))\n\
	ldi r31,hi8(gs(1f))\n\
	%~jmp __prologue_saves__+((18 - %0) * 2)\n\
1:",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_call_prologue_saves,
    &operand_data[224],
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3231 */
  {
    "epilogue_restores",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi r30, lo8(%0)\n\
	%~jmp __epilogue_restores__ + ((18 - %0) * 2)",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_epilogue_restores,
    &operand_data[224],
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3249 */
  {
    "return",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3256 */
  {
    "return_from_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3266 */
  {
    "return_from_interrupt_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "reti",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_interrupt_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3276 */
  {
    "return_from_naked_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_naked_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:120 */
  {
    "nonlocal_goto_receiver",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_nonlocal_goto_receiver,
    &operand_data[0],
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:150 */
  {
    "nonlocal_goto",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_nonlocal_goto,
    &operand_data[226],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:226 */
  {
    "movqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movqi,
    &operand_data[230],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:258 */
  {
    "movqi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[232],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:272 */
  {
    "movhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movhi,
    &operand_data[235],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:317 */
  {
    "movhi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[237],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:346 */
  {
    "movhi+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[240],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:360 */
  {
    "movsi-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[242],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:377 */
  {
    "movsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movsi,
    &operand_data[246],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:393 */
  {
    "movsi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[248],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:427 */
  {
    "movsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movsf,
    &operand_data[251],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:454 */
  {
    "movmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movmemhi,
    &operand_data[253],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:519 */
  {
    "setmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_setmemhi,
    &operand_data[257],
    5,
    1,
    1,
    0
  },
  /* ../../gcc/config/avr/avr.md:584 */
  {
    "strlenhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_strlenhi,
    &operand_data[262],
    4,
    5,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:636 */
  {
    "addhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_addhi3,
    &operand_data[266],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:917 */
  {
    "mulqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulqi3,
    &operand_data[269],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:941 */
  {
    "mulqi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulqi3_call,
    &operand_data[269],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:980 */
  {
    "mulhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulhi3,
    &operand_data[272],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1009 */
  {
    "mulhi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulhi3_call,
    &operand_data[272],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1030 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulsi3,
    &operand_data[275],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1057 */
  {
    "divmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodqi4,
    &operand_data[278],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1079 */
  {
    "udivmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodqi4,
    &operand_data[278],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1099 */
  {
    "divmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodhi4,
    &operand_data[282],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1121 */
  {
    "udivmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodhi4,
    &operand_data[282],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1143 */
  {
    "divmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodsi4,
    &operand_data[286],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1165 */
  {
    "udivmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodsi4,
    &operand_data[286],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1268 */
  {
    "udivmodsi4+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1412 */
  {
    "rotlqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_rotlqi3,
    &operand_data[293],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1432 */
  {
    "rotlhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_rotlhi3,
    &operand_data[296],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1443 */
  {
    "rotlhi3+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[266],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1463 */
  {
    "rotlsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_rotlsi3,
    &operand_data[299],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1476 */
  {
    "rotlsi3+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1512 */
  {
    "rotlsi3+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1562 */
  {
    "ashlqi3-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1615 */
  {
    "ashlqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_ashlqi3,
    &operand_data[302],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1622 */
  {
    "ashlqi3+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1631 */
  {
    "ashlqi3+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1641 */
  {
    "ashlqi3+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1680 */
  {
    "ashlqi3+4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1691 */
  {
    "ashlqi3+5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1703 */
  {
    "lshrqi3-5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1715 */
  {
    "lshrqi3-4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[307],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1735 */
  {
    "lshrqi3-3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[311],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1787 */
  {
    "lshrqi3-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[307],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1807 */
  {
    "lshrqi3-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[311],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1830 */
  {
    "lshrqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_lshrqi3,
    &operand_data[302],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1837 */
  {
    "lshrqi3+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1846 */
  {
    "lshrqi3+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1856 */
  {
    "lshrqi3+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[290],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1895 */
  {
    "lshrqi3+4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1906 */
  {
    "lshrqi3+5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1918 */
  {
    "lshrqi3+6",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[305],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1930 */
  {
    "lshrqi3+7",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[307],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1950 */
  {
    "lshrqi3+8",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[311],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2112 */
  {
    "lshrqi3+9",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[315],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2127 */
  {
    "beq-8",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[277],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2142 */
  {
    "beq-7",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[317],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2157 */
  {
    "beq-6",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[319],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2172 */
  {
    "beq-5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[321],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2187 */
  {
    "beq-4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[323],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "beq-3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[177],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "beq-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[178],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "beq-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[179],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2406 */
  {
    "beq",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_beq,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2414 */
  {
    "bne",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bne,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2422 */
  {
    "bge",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bge,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2430 */
  {
    "bgeu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgeu,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2438 */
  {
    "blt",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_blt,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2446 */
  {
    "bltu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bltu,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2461 */
  {
    "ble",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_ble,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2469 */
  {
    "bleu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bleu,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2477 */
  {
    "bgt",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgt,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2485 */
  {
    "bgtu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgtu,
    &operand_data[183],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2559 */
  {
    "bgtu+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[325],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2573 */
  {
    "bgtu+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[325],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2587 */
  {
    "bgtu+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[327],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2599 */
  {
    "call-3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[327],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2611 */
  {
    "call-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[329],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2623 */
  {
    "call-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[329],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2719 */
  {
    "call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_call,
    &operand_data[331],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2728 */
  {
    "call_value",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_call_value,
    &operand_data[333],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2891 */
  {
    "casesi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_casesi,
    &operand_data[336],
    10,
    7,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:3050 */
  {
    "casesi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_221 },
#else
    { 0, 0, output_221 },
#endif
    0,
    &operand_data[346],
    3,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:3088 */
  {
    "casesi+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_222 },
#else
    { 0, 0, output_222 },
#endif
    0,
    &operand_data[349],
    3,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:3122 */
  {
    "casesi+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_223 },
#else
    { 0, 0, output_223 },
#endif
    0,
    &operand_data[347],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:3152 */
  {
    "prologue-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpse %0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[325],
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3161 */
  {
    "prologue-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpse %0,%1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[352],
    3,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:3285 */
  {
    "prologue",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_prologue,
    &operand_data[0],
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:3294 */
  {
    "epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
