static const char *const multilib_raw[] = {
". !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr2 mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr25 !mmcu=avr2 mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr3 !mmcu=avr2 !mmcu=avr25 mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr31 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr35 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr4 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 mmcu=avr4 !mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr5 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 mmcu=avr5 !mmcu=avr51 !mmcu=avr6;",
"avr51 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 mmcu=avr51 !mmcu=avr6;",
"avr6 !mmcu=avr2 !mmcu=avr25 !mmcu=avr3 !mmcu=avr31 !mmcu=avr35 !mmcu=avr4 !mmcu=avr5 !mmcu=avr51 mmcu=avr6;",
NULL
};

static const char *const multilib_matches_raw[] = {
"mmcu=ata6289 mmcu=avr25;",
"mmcu=attiny13 mmcu=avr25;",
"mmcu=attiny13a mmcu=avr25;",
"mmcu=attiny2313 mmcu=avr25;",
"mmcu=attiny24 mmcu=avr25;",
"mmcu=attiny44 mmcu=avr25;",
"mmcu=attiny84 mmcu=avr25;",
"mmcu=attiny25 mmcu=avr25;",
"mmcu=attiny45 mmcu=avr25;",
"mmcu=attiny85 mmcu=avr25;",
"mmcu=attiny261 mmcu=avr25;",
"mmcu=attiny461 mmcu=avr25;",
"mmcu=attiny861 mmcu=avr25;",
"mmcu=attiny43u mmcu=avr25;",
"mmcu=attiny87 mmcu=avr25;",
"mmcu=attiny48 mmcu=avr25;",
"mmcu=attiny88 mmcu=avr25;",
"mmcu=at86rf401 mmcu=avr25;",
"mmcu=at43usb355 mmcu=avr3;",
"mmcu=at76c711 mmcu=avr3;",
"mmcu=atmega103 mmcu=avr31;",
"mmcu=at43usb320 mmcu=avr31;",
"mmcu=at90usb82 mmcu=avr35;",
"mmcu=at90usb162 mmcu=avr35;",
"mmcu=attiny167 mmcu=avr35;",
"mmcu=attiny327 mmcu=avr35;",
"mmcu=atmega48 mmcu=avr4;",
"mmcu=atmega48p mmcu=avr4;",
"mmcu=atmega8 mmcu=avr4;",
"mmcu=atmega8515 mmcu=avr4;",
"mmcu=atmega8535 mmcu=avr4;",
"mmcu=atmega88 mmcu=avr4;",
"mmcu=atmega88p mmcu=avr4;",
"mmcu=atmega8hva mmcu=avr4;",
"mmcu=atmega4hvd mmcu=avr4;",
"mmcu=atmega8hvd mmcu=avr4;",
"mmcu=atmega8c1 mmcu=avr4;",
"mmcu=atmega8m1 mmcu=avr4;",
"mmcu=at90pwm1 mmcu=avr4;",
"mmcu=at90pwm2 mmcu=avr4;",
"mmcu=at90pwm2b mmcu=avr4;",
"mmcu=at90pwm3 mmcu=avr4;",
"mmcu=at90pwm3b mmcu=avr4;",
"mmcu=at90pwm81 mmcu=avr4;",
"mmcu=atmega16 mmcu=avr5;",
"mmcu=atmega161 mmcu=avr5;",
"mmcu=atmega162 mmcu=avr5;",
"mmcu=atmega163 mmcu=avr5;",
"mmcu=atmega164p mmcu=avr5;",
"mmcu=atmega165 mmcu=avr5;",
"mmcu=atmega165p mmcu=avr5;",
"mmcu=atmega168 mmcu=avr5;",
"mmcu=atmega168p mmcu=avr5;",
"mmcu=atmega169 mmcu=avr5;",
"mmcu=atmega169p mmcu=avr5;",
"mmcu=atmega32 mmcu=avr5;",
"mmcu=atmega323 mmcu=avr5;",
"mmcu=atmega324p mmcu=avr5;",
"mmcu=atmega325 mmcu=avr5;",
"mmcu=atmega325p mmcu=avr5;",
"mmcu=atmega3250 mmcu=avr5;",
"mmcu=atmega3250p mmcu=avr5;",
"mmcu=atmega328p mmcu=avr5;",
"mmcu=atmega329 mmcu=avr5;",
"mmcu=atmega329p mmcu=avr5;",
"mmcu=atmega3290 mmcu=avr5;",
"mmcu=atmega3290p mmcu=avr5;",
"mmcu=atmega406 mmcu=avr5;",
"mmcu=atmega64 mmcu=avr5;",
"mmcu=atmega640 mmcu=avr5;",
"mmcu=atmega644 mmcu=avr5;",
"mmcu=atmega644p mmcu=avr5;",
"mmcu=atmega645 mmcu=avr5;",
"mmcu=atmega6450 mmcu=avr5;",
"mmcu=atmega649 mmcu=avr5;",
"mmcu=atmega6490 mmcu=avr5;",
"mmcu=atmega16hva mmcu=avr5;",
"mmcu=atmega16hvb mmcu=avr5;",
"mmcu=atmega32hvb mmcu=avr5;",
"mmcu=at90can32 mmcu=avr5;",
"mmcu=at90can64 mmcu=avr5;",
"mmcu=at90pwm216 mmcu=avr5;",
"mmcu=at90pwm316 mmcu=avr5;",
"mmcu=atmega16c1 mmcu=avr5;",
"mmcu=atmega32c1 mmcu=avr5;",
"mmcu=atmega64c1 mmcu=avr5;",
"mmcu=atmega16m1 mmcu=avr5;",
"mmcu=atmega32m1 mmcu=avr5;",
"mmcu=atmega64m1 mmcu=avr5;",
"mmcu=atmega16u4 mmcu=avr5;",
"mmcu=atmega32u4 mmcu=avr5;",
"mmcu=atmega32u6 mmcu=avr5;",
"mmcu=at90scr100 mmcu=avr5;",
"mmcu=at90usb646 mmcu=avr5;",
"mmcu=at90usb647 mmcu=avr5;",
"mmcu=at94k mmcu=avr5;",
"mmcu=atmega128 mmcu=avr51;",
"mmcu=atmega1280 mmcu=avr51;",
"mmcu=atmega1281 mmcu=avr51;",
"mmcu=atmega1284p mmcu=avr51;",
"mmcu=atmega128rfa1 mmcu=avr51;",
"mmcu=at90can128 mmcu=avr51;",
"mmcu=at90usb1286 mmcu=avr51;",
"mmcu=at90usb1287 mmcu=avr51;",
"mmcu=m3000f mmcu=avr51;",
"mmcu=m3000s mmcu=avr51;",
"mmcu=m3001b mmcu=avr51;",
"mmcu=atmega2560 mmcu=avr6;",
"mmcu=atmega2561 mmcu=avr6;",
"mmcu=avr2 mmcu=avr2;",
"mmcu=avr25 mmcu=avr25;",
"mmcu=avr3 mmcu=avr3;",
"mmcu=avr31 mmcu=avr31;",
"mmcu=avr35 mmcu=avr35;",
"mmcu=avr4 mmcu=avr4;",
"mmcu=avr5 mmcu=avr5;",
"mmcu=avr51 mmcu=avr51;",
"mmcu=avr6 mmcu=avr6;",
NULL
};

static const char *multilib_extra = "";

static const char *const multilib_exclusions_raw[] = {
NULL
};

static const char *multilib_options = "mmcu=avr2/mmcu=avr25/mmcu=avr3/mmcu=avr31/mmcu=avr35/mmcu=avr4/mmcu=avr5/mmcu=avr51/mmcu=avr6";
